diff -Naur --exclude=CVS --exclude=configs linux/hpc/dfsa.c linux-openmosix/hpc/dfsa.c
--- linux/hpc/dfsa.c	1970-01-01 01:00:00.000000000 +0100
+++ linux-openmosix/hpc/dfsa.c	2003-09-10 20:50:13.000000000 +0200
@@ -0,0 +1,2692 @@
+/* All changes since Feb 12, 2002 by Moshe Bar
+ * Copyright (C) 2000, 2001, Amnon Barak (amnon@cs.huji.ac.il)
+ *
+ * Permission to use this software is hereby granted under the terms of the
+ * GNU General Public License, as published by the Free Software Foundation.
+ *
+ * Author(s): Amnon Shiloh, Moshe Bar
+ */
+
+#include <linux/sched.h>
+#include <asm/uaccess.h>
+#include <linux/hpc.h>
+#include <hpc/protocol.h>
+#include <linux/smp_lock.h>
+#include <linux/slab.h>
+#include <linux/stddef.h>
+#include <linux/module.h>
+#include <hpc/routines.h>
+#include <hpc/defs.h>
+#include <hpc/comm.h>
+#include <hpc/debug.h>
+#include <linux/fs.h>
+#include <linux/file.h>
+#include <linux/proc_fs.h>
+
+#ifdef CONFIG_MOSIX_DFSA
+#include <hpc/dfsa.h>
+
+#define	CLEAR_ALL(fls,fld)	memset(fls->fld, 0, fls->max_fdset/8)
+
+struct dfsatab *dfsatab;
+struct vfsmount *dfsa_mounts[MAXDFSAFS];
+struct
+{
+	struct vfsmount *mnt;
+	struct dentry *dentry;
+} dfsa_links[MAXDFSALINKS];
+char dfsa_being_cancelled[MAXDFSAFS];
+char dfsa_recheck_mount[MAXDFSAFS];
+struct dentry *bad_deputy_dfsaentry;
+int dfsa_disabled = 1;
+DECLARE_MUTEX(dfsa_modify_lock);
+
+extern struct inode_operations all_bad_inode_operations;
+extern struct file_operations all_bad_file_operations;
+extern struct super_block bad_super_block;
+
+void
+dfsa_init(void)
+{
+	struct inode *ip;
+
+	if(!(dfsatab = kmalloc(sizeof(struct dfsatab), GFP_KERNEL)))
+		panic("dfsa_init");
+	dfsatab->len = sizeof(struct dfsatab);
+	dfsatab->ndefs = 0;
+	if(!(bad_deputy_dfsaentry =
+			d_alloc(NULL, &(const struct qstr) { "/", 1, 0 })))
+		panic("dfsa_init: d_alloc");
+	if(!(ip = new_inode(&bad_super_block)))
+		panic("dfsa_init: empty inode");
+	ip->i_mode = S_IFREG;
+	ip->i_op = &all_bad_inode_operations;
+	ip->i_fop = &all_bad_file_operations;
+	bad_deputy_dfsaentry->d_inode = ip;
+	bad_deputy_dfsaentry->d_parent = bad_deputy_dfsaentry;
+	dfsa_disabled = 0;
+}
+
+int
+dfsa_option(char *data, int *result)
+{
+	int n;
+	int has = 0;
+
+	if(!data)
+		return(0);
+	while(1)
+	{
+		while(*data && (*data != 'd' || *(data+1) != 'f' ||
+			*(data+2) != 's' || *(data+3) != 'a' ||
+			*(data+4) != '='))
+			data++;
+		if(!*data)
+			return(has);
+		data += 5;
+		if(*data < '0' || *data > '9')
+		{
+			printk("WARNING: Invalid 'dfsa=' value <%s>\n", data);
+			continue;
+		}
+		for(n = 0 ; *data >= '0' && *data <= '9' ; data++)
+		{
+			n = n * 10 + *data - '0';
+			if(n > 32767)
+				break;
+		}
+		if(n <= 32767)
+		{
+			has = 1;
+			*result = n;
+		}
+		else
+			printk("DFSA-number option overflow!\n");
+	}
+	return(has);
+}
+
+void
+dfsa_is_not_up_to_date(void)
+{
+	tell_process(current, DREQ_NOTUPTODATE);
+}
+
+void
+dfsa_pwd_changed(void)
+{
+	current->mosix.dupdates |= DFSA_UPDCDIR;
+}
+
+#define	DFSA_MOUNT_MOUNTED	1
+#define	DFSA_MOUNT_RDONLY	2
+#define	DFSA_MOUNT_SYNC		4
+#define	DFSA_MOUNT_NOATIME	8
+#define	DFSA_MOUNT_NODIRATIME	16
+#define	DFSA_MOUNT_SYMLINK	32
+
+int
+important_fs_flags(unsigned long flags)
+{
+	int f = DFSA_MOUNT_MOUNTED;
+
+	if(flags & MS_RDONLY)
+		f |= DFSA_MOUNT_RDONLY;
+	if(flags & MS_SYNCHRONOUS)
+		f |= DFSA_MOUNT_SYNC;
+	if(flags & MS_NOATIME)
+		f |= DFSA_MOUNT_NOATIME;
+	if(flags & MS_NODIRATIME)
+		f |= DFSA_MOUNT_NODIRATIME;
+	return(f);
+}
+
+/*
+ * 0 = same
+ * 1 = first string comes first
+ * -1 = second string comes first
+ * normally sorted alphabetically -
+ * but if one string begins with the other, the LONGER comes first.
+ */
+static inline int
+dfsa_name_compare(char *n1, char *n2)
+{
+	register unsigned char *u1, *u2;
+	int a, b;
+
+	for(u1 = n1 , u2 = n2 ; *u1 && *u1 == *u2 ; u1++ , u2++)
+		;
+	a = *u1;
+	b = *u2;
+	if(!a)
+		return(b ? -1 : 0);
+	if(!b || a < b)
+		return(1);
+	return(-1);
+}
+
+static inline char *
+mntpath(struct vfsmount *mnt)
+{
+	char *page = (char *)__get_free_page(GFP_KERNEL);
+	struct vfsmount *rootmnt;
+	struct dentry *root;
+
+	if(!page)
+		return(NULL);
+	read_lock(&init_task.fs->lock);
+	rootmnt = mntget(init_task.fs->rootmnt);
+	root = dget(init_task.fs->root);
+	read_unlock(&init_task.fs->lock);
+	spin_lock(&dcache_lock);
+	page = __d_path(mnt->mnt_root, mnt, root, rootmnt, page, PAGE_SIZE);
+	spin_unlock(&dcache_lock);
+	dput(root);
+	mntput(rootmnt);
+	return(page);
+}
+
+static inline void
+dfsa_set_dfsa(struct vfsmount *mnt, int now, int prev)
+{
+	int differ = (mnt->mnt_dfsano != now);
+
+	MOSIX_LOCKED;
+	mnt->mnt_dfsaprev = prev;
+	mnt->mnt_dfsano = now;
+	if(differ && mnt->mnt_sb->s_op->dfsa_changed)
+		mnt->mnt_sb->s_op->dfsa_changed(mnt, now);
+}
+
+int
+dfsa_setmnt(struct vfsmount *mnt, int num, unsigned long flags)
+{
+	int ind, sz, oldnum = 0;
+	register int i, j;
+	char *x, *y;
+	struct dfsatab *new, *old;
+	int error = 0;
+	int c;
+	unsigned int done;
+	char *dir;
+	struct super_block *sb;
+
+	if(num < 0 || num > MAXDFSAFS)
+	{
+		printk("Invalid DFSA index (%d), range is 1-%d "
+			"(or 0 to cancel)\n", num, MAXDFSAFS);
+		return(-EINVAL);
+	}
+	sb = mnt->mnt_sb;
+	if(num && (!sb->s_op || !sb->s_op->identify || !sb->s_op->reconstruct))
+	{
+		printk("%s: Not a DFSA-compatible file-system\n",
+							sb->s_type->name);
+		return(-EPERM);
+	}
+	if(!(dir = mntpath(mnt)))
+		return(-ENOMEM);
+	error = -EBUSY;
+	if(down_interruptible(&dfsa_modify_lock))
+		goto freedir;
+	lock_mosix();
+	if(dfsa_disabled)
+	{
+		if(num == 0)
+			error = 0;
+		goto out;
+	}
+	sz = sizeof(struct dfsatab);
+	ind = -1;
+	for(i = 0 ; i < dfsatab->ndefs ; i++)
+	{
+		x = &((char *)dfsatab)[dfsatab->dfsdef[i].offset];
+		if(!strcmp(dir, x))
+		{
+			oldnum = dfsatab->dfsdef[i].defno;
+			if(oldnum == num && dfsatab->dfsdef[i].mounted ==
+						important_fs_flags(flags))
+			{
+				error = 0;	/* nothing to do */
+				goto out;
+			} 
+			if(oldnum > MAXDFSAFS)
+			{
+				printk("Conflict: mount-point <%s> is declared "
+					"as a DFSA symbolic link\n", dir);
+				error = -EBUSY;
+				goto out;
+			}
+			ind = i;
+		}
+		else if(dfsatab->dfsdef[i].defno == num)
+		{
+			printk("DFSA entry #%d already held for <%s>\n",num, x);
+			error = -EBUSY;
+			goto out;
+		}
+		else
+			sz += sizeof(struct dfsdef) + strlen(x) + 1;
+	}
+	if(ind == -1 && num == 0)
+	{
+		error = 0;	/* nothing to do */
+		goto out;
+	}
+	if(num)
+		sz += sizeof(struct dfsdef) + strlen(dir) + 1;
+	unlock_mosix();
+	new = (sz >= 65535) ? NULL : kmalloc(sz, GFP_KERNEL);
+	lock_mosix();
+	if(!new)
+	{
+		error = -ENOMEM;
+		goto out;
+	}
+	if(ind != -1)
+	{
+		if(num)
+			printk("Changing DFSA index of <%s> from %d to %d\n",
+				dir, oldnum, num);
+		else
+			printk("Cancelling DFSA entry #%d (was <%s>)\n",
+				oldnum, dir);
+		dfsa_being_cancelled[oldnum-1] = 1;
+		dfsa_set_dfsa(mnt, 0, mnt->mnt_dfsano);
+		unlock_mosix();
+		error = dfsa_sync(1);
+		lock_mosix();
+		if(error)
+		{
+			printk("DFSA interrupted: not %s <%s>\n",
+				num ? "Changing" : "Cancelling", dir);
+			dfsa_set_dfsa(mnt, mnt->mnt_dfsaprev, 0);
+			dfsa_being_cancelled[oldnum-1] = 0;
+			dfsa_sync(0);
+			kfree(new);
+			goto out;
+		}
+		mntput(dfsa_mounts[oldnum-1]);
+		dfsa_mounts[oldnum-1] = NULL;
+		dfsa_set_dfsa(mnt, num, 0);
+		dfsa_being_cancelled[oldnum-1] = 0;
+	}
+	else
+	{
+		printk("Adding <%s> as DFSA entry #%d\n", dir, num);
+		dfsa_set_dfsa(mnt, num, 0);
+	}
+	/* compile the new table */
+	new->len = sz;
+	new->ndefs = dfsatab->ndefs - (ind != -1) + (num != 0);
+	y = (char *)&new->dfsdef[(int)new->ndefs];
+	done = 0;
+	for(j = i = 0 ; i < dfsatab->ndefs ; i++)
+	{
+		x = &((char *)dfsatab)[dfsatab->dfsdef[i].offset];
+		if(!done && (c = dfsa_name_compare(dir, x)) <= 0)
+		{
+			done = 1;
+			if(num)
+			{
+				new->dfsdef[j].defno = num;
+				new->dfsdef[j].mounted =
+						important_fs_flags(flags);
+				new->dfsdef[j].offset = y - (char *)new;
+				strcpy(y, dir);
+				while(*y++)
+					;
+				j++;
+			}
+			if(c == 0)
+				continue;
+		}
+		new->dfsdef[j] = dfsatab->dfsdef[i];
+		new->dfsdef[j].offset = y - (char *)new;
+		while(*x)
+			*y++ = *x++;
+		*y++ = '\0';
+		j++;
+	}
+	if(num && !done)
+	{
+		new->dfsdef[j].defno = num;
+		new->dfsdef[j].mounted = important_fs_flags(flags);
+		new->dfsdef[j].offset = y - (char *)new;
+		strcpy(y, dir);
+	}
+	old = dfsatab;
+	dfsatab = new;
+	if(num)
+		dfsa_mounts[num-1] = mntget(mnt);
+	kfree(old);
+	dfsa_sync(0);
+	error = 0;
+	out:
+	unlock_mosix();
+	up(&dfsa_modify_lock);
+	freedir:
+	free_page(((unsigned long)dir) & PAGE_MASK);
+	return(error);
+}
+
+int
+dfsa_addlink(char *link)
+{
+	int i = strlen(link), j;
+	char *x, *y;
+	int ret;
+	struct nameidata nd;
+	struct vfsmount *mnt;
+	struct dentry *dp;
+	struct dfsatab *new, *old;
+	int sz = sizeof(struct dfsatab) + sizeof(struct dfsdef) + i + 1;
+	int linkno;
+	unsigned int added = 0;
+	umode_t mode;
+
+	if(i > MAXDFSALINKLEN)
+		return(-ENAMETOOLONG);
+	if(*link != '/')
+	{
+		printk("DFSA: <%s> must be an absolute path-name.\n", link);
+		return(-EINVAL);
+	}
+	if (path_init(link, LOOKUP_POSITIVE, &nd) && (ret=path_walk(link, &nd)))
+		return(ret);
+	ret = -EINVAL;
+	if(!S_ISLNK(nd.dentry->d_inode->i_mode))
+	{
+		printk("DFSA: <%s> is not a link!\n", link);
+		goto release;
+	}
+	path_release(&nd);
+	if (path_init(link, LOOKUP_POSITIVE|LOOKUP_FOLLOW, &nd) &&
+		(ret = path_walk(link, &nd)))
+	{
+		printk("DFSA: <%s> symlink is loose (errno=%d)\n", link, ret);
+		return(-EINVAL);
+	}
+	mode = nd.dentry->d_inode->i_mode;
+	if(!S_ISREG(mode) && !S_ISDIR(mode) && !S_ISLNK(mode))
+	{
+		printk("DFSA: <%s> points to a special file!\n", link);
+		goto release;
+	}
+	if(!nd.mnt->mnt_sb->s_op->identify)
+	{
+		printk("<%s> points to a file-system not supported by DFSA.\n",
+									link);
+		goto release;
+	}
+	ret = -EINTR;
+	if(down_interruptible(&dfsa_modify_lock))
+		goto release;
+	lock_mosix();
+	for(i = 0 ; i < dfsatab->ndefs ; i++)
+	{
+		x = &((char *)dfsatab)[dfsatab->dfsdef[i].offset];
+		if(!strcmp(x, link))
+		{
+			if(dfsatab->dfsdef[i].defno <= MAXDFSAFS)
+			{
+				printk("Conflict: DFSA link <%s> is declared "
+					"as a mount-point\n", link);
+				ret = -EBUSY;
+				goto out;
+			}
+			linkno = dfsatab->dfsdef[i].defno - (MAXDFSAFS+1);
+			mnt = dfsa_links[linkno].mnt;
+			dp = dfsa_links[linkno].dentry;
+			ret = 0;
+			if(mnt == nd.mnt && dp->d_inode == nd.dentry->d_inode)
+				goto out;
+			printk("Updating DFSA link <%s>\n", link);
+			printk("[But please, next time delete the DFSA-link "
+				"BEFORE changing the symbolic-link]!\n");
+			dfsa_links[linkno].mnt = mntget(nd.mnt);
+			dfsa_links[linkno].dentry = dget(nd.dentry);
+			unlock_mosix();
+			mntput(mnt);
+			dput(dp);
+			lock_mosix();
+			goto sync;
+		}
+		sz += sizeof(struct dfsdef) + strlen(x) + 1;
+	}
+	ret = -EMLINK;
+	for(linkno = 0 ; linkno < MAXDFSALINKS ; linkno++)
+	if(!dfsa_links[linkno].mnt)
+		break;
+	if(linkno == MAXDFSALINKS)
+		goto out;
+	unlock_mosix();
+	new = (struct dfsatab *)kmalloc(sz, GFP_KERNEL);
+	lock_mosix();
+	ret = -ENOMEM;
+	if(!new)
+		goto out;
+	printk("Adding DFSA link <%s>\n", link);
+	dfsa_links[linkno].mnt = mntget(nd.mnt);
+	dfsa_links[linkno].dentry = dget(nd.dentry);
+	ret = 0;
+	new->len = sz;  /* bug??? */
+
+	new->ndefs = dfsatab->ndefs + 1;
+	y = (char *)&new->dfsdef[(int)new->ndefs];
+	for(j = i = 0 ; i < dfsatab->ndefs ; i++)
+	{
+		x = &((char *)dfsatab)[dfsatab->dfsdef[i].offset];
+		if(!added && dfsa_name_compare(link, x) == 1)
+		{
+			added = 1;
+			new->dfsdef[j].defno = linkno + MAXDFSAFS + 1;
+			new->dfsdef[j].mounted = 0;
+			new->dfsdef[j].offset = y - (char *)new;
+			strcpy(y, link);
+			while(*y++)
+				;
+			j++;
+		}
+		new->dfsdef[j] = dfsatab->dfsdef[i];
+		new->dfsdef[j].offset = y - (char *)new;
+		while(*x)
+			*y++ = *x++;
+		*y++ = '\0';
+		j++;
+	}
+	if(!added)
+	{
+		new->dfsdef[j].defno = linkno + MAXDFSAFS + 1;
+		new->dfsdef[j].mounted = 0;
+		new->dfsdef[j].offset = y - (char *)new;
+		strcpy(y, link);
+		while(*y++)
+			;
+	}
+	old = dfsatab;
+	dfsatab = new;
+	kfree(old);
+	sync:
+	dfsa_sync(0);
+	out:
+	unlock_mosix();
+	up(&dfsa_modify_lock);
+	release:
+	path_release(&nd);
+	return(ret);
+}
+
+int
+dfsa_dellink(char *link)
+{
+	int i, j;
+	char *x, *y;
+	int ret;
+	struct vfsmount *mnt;
+	struct dentry *dp;
+	struct dfsatab *new, *old;
+	int sz = sizeof(struct dfsatab);
+	int ind = -1;
+	int linkno = 0;
+
+	if(down_interruptible(&dfsa_modify_lock))
+		return(-EINTR);
+	lock_mosix();
+	for(i = 0 ; i < dfsatab->ndefs ; i++)
+	{
+		x = &((char *)dfsatab)[dfsatab->dfsdef[i].offset];
+		if(dfsatab->dfsdef[i].defno <= MAXDFSAFS || strcmp(x, link))
+			sz += sizeof(struct dfsdef) + strlen(x) + 1;
+		else
+		{
+			ind = i;
+			linkno = dfsatab->dfsdef[i].defno - MAXDFSAFS - 1;
+		}
+	}
+	ret = -EINVAL;
+	if(ind == -1)
+		goto out;
+	unlock_mosix();
+	new = (struct dfsatab *)kmalloc(sz, GFP_KERNEL);
+	lock_mosix();
+	ret = -ENOMEM;
+	if(!new)
+		goto out;
+	ret = 0;
+	printk("Deleting DFSA link <%s>\n", link);
+	new->len = sz;
+	new->ndefs = dfsatab->ndefs - 1;
+	y = (char *)&new->dfsdef[(int)new->ndefs];
+	for(j = i = 0 ; i < dfsatab->ndefs ; i++)
+	if(i != ind)
+	{
+		x = &((char *)dfsatab)[dfsatab->dfsdef[i].offset];
+		new->dfsdef[j] = dfsatab->dfsdef[i];
+		new->dfsdef[j].offset = y - (char *)new;
+		while(*x)
+			*y++ = *x++;
+		*y++ = '\0';
+		j++;
+	}
+	old = dfsatab;
+	dfsatab = new;
+	unlock_mosix();
+	i = dfsa_sync(1);
+	lock_mosix();
+	if(i)
+	{
+		printk("Clearing of DFSA links interrupted!\n");
+		dfsatab = old;
+		kfree(new);
+		ret = -EINTR;
+		goto out;
+	}
+	kfree(old);
+	mnt = dfsa_links[linkno].mnt;
+	dfsa_links[linkno].mnt = NULL;
+	dp = dfsa_links[linkno].dentry;
+	dfsa_links[linkno].dentry = NULL;
+	unlock_mosix();
+	mntput(mnt);
+	dput(dp);
+	lock_mosix();
+	out:
+	unlock_mosix();
+	up(&dfsa_modify_lock);
+	return(ret);
+}
+
+int
+dfsa_clearlinks(void)
+{
+	int i, j;
+	char *x, *y;
+	int ret;
+	struct vfsmount *mnt;
+	struct dentry *dp;
+	struct dfsatab *new = NULL, *old;
+	int sz = sizeof(struct dfsatab);
+	unsigned int found = 0;
+
+	if(down_interruptible(&dfsa_modify_lock))
+		return(-EINTR);
+	lock_mosix();
+	for(i = 0 ; i < dfsatab->ndefs ; i++)
+	{
+		if(dfsatab->dfsdef[i].defno <= MAXDFSAFS)
+		{
+			x = &((char *)dfsatab)[dfsatab->dfsdef[i].offset];
+			sz += sizeof(struct dfsdef) + strlen(x) + 1;
+		}
+		else
+			found++;
+	}
+	if(!found)
+	{
+		printk("No DFSA links to clear\n");
+		ret = 0;
+		goto out;
+	}
+	ret = -ENOMEM;
+	unlock_mosix();
+	new = (struct dfsatab *)kmalloc(sz, GFP_KERNEL);
+	lock_mosix();
+	if(!new)
+		goto out;
+	printk("Clearing all DFSA links\n");
+	ret = 0;
+	new->len = sz;
+	new->ndefs = dfsatab->ndefs - found;
+	y = (char *)&new->dfsdef[(int)new->ndefs];
+	for(j = i = 0 ; i < dfsatab->ndefs ; i++)
+	if(dfsatab->dfsdef[i].defno <= MAXDFSAFS)
+	{
+		x = &((char *)dfsatab)[dfsatab->dfsdef[i].offset];
+		new->dfsdef[j] = dfsatab->dfsdef[i];
+		new->dfsdef[j].offset = y - (char *)new;
+		while(*x)
+			*y++ = *x++;
+		*y++ = '\0';
+		j++;
+	}
+	old = dfsatab;
+	dfsatab = new;
+	unlock_mosix();
+	i = dfsa_sync(1);
+	lock_mosix();
+	if(i)
+	{
+		printk("Clearing of DFSA links interrupted!\n");
+		dfsatab = old;
+		kfree(new);
+		ret = -EINTR;
+		goto out;
+	}
+	kfree(old);
+	for(i = 0 ; i < MAXDFSALINKS ; i++)
+	if((mnt = dfsa_links[i].mnt))
+	{
+		dp = dfsa_links[i].dentry;
+		dfsa_links[i].mnt = NULL;
+		dfsa_links[i].dentry = NULL;
+		unlock_mosix();
+		mntput(mnt);
+		dput(dp);
+		lock_mosix();
+	}
+	out:
+	unlock_mosix();
+	up(&dfsa_modify_lock);
+	return(ret);
+}
+
+char *
+dfsa_showlinks(void)
+{
+	unsigned int i;
+	int sz;
+	char *x;
+	char *links = NULL, *p;
+
+	lock_mosix();
+	again:
+	for(sz = 1 , i = 0 ; i < dfsatab->ndefs ; i++)
+	if(dfsatab->dfsdef[i].defno > MAXDFSAFS)
+	{
+		x = &((char *)dfsatab)[dfsatab->dfsdef[i].offset];
+		sz += strlen(x) + 1;
+	}
+	unlock_mosix();
+	if(!(links = kmalloc(sz, GFP_KERNEL)))
+		return(NULL);
+	lock_mosix();
+	p = links;
+	for(i = 0 ; i < dfsatab->ndefs ; i++)
+	if(dfsatab->dfsdef[i].defno > MAXDFSAFS)
+	{
+		x = &((char *)dfsatab)[dfsatab->dfsdef[i].offset];
+		while(*x)
+		{
+			*p++ = *x++;
+			if(--sz < 2)
+			{
+				kfree(links);
+				goto again;
+			}
+		}
+		*p++ = '\n';
+		sz--;
+	}
+	*p = '\0';
+	unlock_mosix();
+	return(links);
+}
+
+int
+disable_dfsa(void)
+{
+	unsigned int i;
+	int ret;
+	struct vfsmount *mnt;
+	struct dentry *dp;
+
+	if(down_interruptible(&dfsa_modify_lock))
+		return(-EINTR);
+	lock_mosix();
+	ret = 0;
+	if(dfsa_disabled++)
+		goto out;
+	printk("Disabling DFSA\n");
+	for(i = 0 ; i < MAXDFSAFS ; i++)
+	{
+		dfsa_being_cancelled[i] = 1;
+		if((mnt = dfsa_mounts[i]))
+			dfsa_set_dfsa(mnt, 0, mnt->mnt_dfsa);
+	}
+	if((ret = dfsa_sync(1)))
+	{
+		printk("Disabling DFSA interrupted\n");
+		for(i = 0 ; i < MAXDFSAFS ; i++)
+		if((mnt = dfsa_mounts[i]))
+			dfsa_set_dfsa(mnt, mnt->mnt_dfsaprev, 0);
+		unlock_mosix();
+		enable_dfsa();
+		goto out2;
+	}
+	dfsatab->ndefs = 0;
+	dfsatab->len = sizeof(struct dfsatab);
+	for(i = 0 ; i < MAXDFSAFS ; i++)
+	if((mnt = dfsa_mounts[i-1]))
+	{
+		dfsa_mounts[i-1] = NULL;
+		dfsa_set_dfsa(mnt, 0, 0);
+		unlock_mosix();
+		mntput(mnt);
+		lock_mosix();
+	}
+	for(i = 0 ; i < MAXDFSALINKS ; i++)
+	if((mnt = dfsa_links[i].mnt))
+	{
+		dp = dfsa_links[i].dentry;
+		dfsa_links[i].mnt = NULL;
+		dfsa_links[i].dentry = NULL;
+		unlock_mosix();
+		mntput(mnt);
+		dput(dp);
+		lock_mosix();
+	}
+	out:
+	unlock_mosix();
+	out2:
+	up(&dfsa_modify_lock);
+	return(ret);
+}
+
+void
+enable_dfsa()
+{
+	unsigned int i;
+
+	lock_mosix();
+	if(--dfsa_disabled == 0)
+	{
+		for(i = 0 ; i < MAXDFSAFS ; i++)
+			dfsa_being_cancelled[i] = 0;
+		dfsa_sync(0);
+	}
+	unlock_mosix();
+}
+
+char *
+dfsa_getdir(int num, int *tofree)
+{
+	register unsigned int i, l;
+	char *x, *copy;
+	char *ret;
+
+	*tofree = 0;
+	lock_mosix();
+	again:
+	ret = "\n";
+	for(i = 0 ; i < dfsatab->ndefs ; i++)
+	if(dfsatab->dfsdef[i].defno == num)
+	{
+		x = &((char *)dfsatab)[dfsatab->dfsdef[i].offset];
+		/* try to copy - just in case of changes during copy_to_user: */
+		l = strlen(x);
+		unlock_mosix();
+		copy = kmalloc(l+2, GFP_KERNEL);
+		lock_mosix();
+		if(!copy)
+		{
+			ret = "Sorry: no memory\n";
+			break;
+		}
+		/* paranoid test - did the table change? */
+		if((dfsatab) ||
+			i >= dfsatab->ndefs || dfsatab->dfsdef[i].defno != num ||
+			strlen(x = &((char *)dfsatab)[dfsatab->dfsdef[i].offset]) > l)
+		{
+			kfree(copy);
+			goto again;
+		}
+		sprintf(copy, "%s\n", x);
+		ret = copy;
+		*tofree = 1;
+		break;
+	}
+	unlock_mosix();
+	return(ret);
+}
+
+DECLARE_WAIT_QUEUE_HEAD(wait_for_all_to_dfsasync);
+
+int
+dfsa_all_know(void)
+{
+	register struct task_struct *p;
+
+	read_lock(&tasklist_lock);
+	for_each_task(p)
+	if(process_told(p, DREQ_DFSASYNC))
+		break;
+	read_unlock(&tasklist_lock);
+	return(p == &init_task);
+}
+
+int
+dfsa_sync(int wait)
+{
+	struct task_struct *p;
+	unsigned int any = 0;
+	int ret = 0;
+
+	read_lock(&tasklist_lock);
+	for_each_task(p)
+	if((p->mosix.dflags&(DDEPUTY|DREMOTE)) && !(p->mosix.dflags&DFINISHED))
+	{
+		any = 1;
+		tell_process(p, DREQ_DFSASYNC);
+		wake_up_mosix(p);
+	}
+	read_unlock(&tasklist_lock);
+	if(!any)
+		wake_up(&wait_for_all_to_dfsasync);
+	if(wait)
+	{
+		DECLARE_WAITQUEUE(wait, current);
+
+		add_wait_queue(&wait_for_all_to_dfsasync, &wait);
+		while(1)
+		{
+			set_current_state(TASK_INTERRUPTIBLE);
+			if(dfsa_all_know())
+				break;
+			schedule();
+			if(signal_pending(current))
+			{
+				ret = -EINTR;
+				break;
+			}
+		}
+		remove_wait_queue(&wait_for_all_to_dfsasync, &wait);
+		set_current_state(TASK_RUNNING);
+	}
+	return(ret);
+}
+
+void
+clear_dfsasync(void)
+{
+	if(process_told(current, DREQ_DFSASYNC))
+	{
+		process_ack(current, DREQ_DFSASYNC);
+		if(dfsa_all_know())	/* we were the last to ack */
+			wake_up(&wait_for_all_to_dfsasync);
+		tell_process(current, DREQ_NOTUPTODATE);
+	}
+}
+
+/*
+ * keep only those entries in "*tab" that also appear in our main "dfsatab"
+ * and have the same [important] mount-flags.
+ * both tables are already sorted.
+ */
+void
+dfsa_adapt(struct dfsatab *tab)
+{
+	unsigned int i, j = 0, k = 0;
+	int n1 = tab->ndefs, n2;
+	struct dfsdef *def1, *def2;
+	char *x, *y;
+
+	lock_mosix();
+	n2 = dfsatab->ndefs;
+	def2 = &dfsatab->dfsdef[0];
+	if(n2)
+		for(def1 = tab->dfsdef , i = 0 ; i < n1 ; i++ , def1++)
+		{
+			x = &((char *)tab)[def1->offset];
+		next2:
+			y = &((char *)dfsatab)[def2->offset];
+			switch(dfsa_name_compare(x, y))
+			{
+			case 0:
+				if(def1->mounted == def2->mounted)
+				{
+					if(k != i)
+						tab->dfsdef[k] = tab->dfsdef[i];
+					k++;
+					j++;
+					def2++;
+				}
+			case -1:
+				continue;
+			case 1:
+				j++;
+				def2++;
+				if(j == n2)
+					break;
+				goto next2;
+			}
+		}
+	unlock_mosix();
+	tab->ndefs = k;
+}
+
+int
+name_starts_in_dfsa(char **nam, struct nameidata *nd)
+{
+	register struct dfsatab *tab;
+	register unsigned int i;
+	char *n, *x;
+	struct vfsmount *mnt;
+	int ind;
+
+	lock_mosix();
+	tab = (current->mosix.dflags & DREMOTE) ? current->mosix.ttab : dfsatab;
+	if(tab && !dfsa_disabled)
+	for(i = 0 ; i < tab->ndefs ; i++)
+	{
+		n = *nam;
+		x = &((char *)tab)[tab->dfsdef[i].offset];
+		while(*n && *n == *x)
+		{
+			if(*n == '/')
+			{
+				while(*x == '/')
+					x++;
+				if(*x == '\0')
+					break;
+				while(*n == '/')
+				{
+					n++;
+					if(*n == '.' && (*(n+1) == '\0' ||
+								*(n+1) == '/'))
+						n++;
+				}
+			}
+			else
+			{
+				n++;
+				x++;
+			}
+		}
+		if(*x || (*n && *n != '/'))
+			continue;
+		if((nd->flags & LOOKUP_PARENT) || (!tab->dfsdef[i].mounted &&
+			 !*n && !(nd->flags & LOOKUP_FOLLOW)))
+		{
+			while(*n == '/')
+				n++;
+			if(!*n)
+				continue;
+		}
+		else while(*n == '/')
+			n++;
+		ind = tab->dfsdef[i].defno - 1;
+		if(ind < MAXDFSAFS)
+		{
+			if(dfsa_being_cancelled[ind] ||
+						!(mnt = dfsa_mounts[ind]))
+				break;
+			nd->mnt = mntget(mnt);
+			nd->dentry = dget(mnt->mnt_root); 
+		}
+		else
+		{
+			ind -= MAXDFSAFS;
+			if(!(mnt = dfsa_links[ind].mnt))
+				break;
+			if(!mnt->mnt_dfsano)
+				break;
+			nd->mnt = mntget(mnt);
+			nd->dentry = dget(dfsa_links[ind].dentry);
+		}
+		*nam = n;
+		unlock_mosix();
+		return(1);
+	}
+	unlock_mosix();
+	return(0);
+}
+
+int
+within_dfsa(struct nameidata *nd)
+{
+	int dfsano;
+	struct dfsatab *tab;
+	struct dfsdef *def;
+	int i;
+	int ret;
+
+	lock_mosix();
+	if(dfsa_disabled || !(dfsano = nd->mnt->mnt_dfsano) ||
+		dfsa_being_cancelled[dfsano-1] || !(dfsa_mounts[dfsano-1]))
+		ret = 0;
+	else if(!(current->mosix.dflags & DREMOTE))
+		ret = 1;
+	else if(!(tab = current->mosix.ttab) || nd->mnt->mnt_dfsaprev)
+		ret = 0;
+	else
+	{
+		ret = 0;
+		for(def = tab->dfsdef , i = tab->ndefs ; i > 0 ; i-- , def++)
+		if(def->defno == dfsano)
+		{
+			ret = 1;
+			break;
+		}
+	}
+	unlock_mosix();
+	return(ret);
+}
+
+void
+dfsa_close_file(int fd)
+{
+	register struct task_struct *p = current;
+	register struct files_struct *files = current->files;
+
+	if(atomic_read(&files->users) > 1)
+	{
+		tell_process(p, DREQ_NOTUPTODATE);
+		return;
+	}
+	if(fd >= files->maxclosed)
+		files->maxclosed = fd + 1;
+	FD_SET(fd, files->closed);
+	p->mosix.dupdates |= DFSA_UPDCLOSE;
+}
+
+void
+dfsa_open_file(int fd)
+{
+	struct task_struct *p = current;
+	register struct files_struct *files = p->files;
+	struct file *f;
+	int n;
+
+	if(atomic_read(&files->users) > 1)
+	{
+		tell_process(p, DREQ_NOTUPTODATE);
+		return;
+	}
+	/* since nobody shares our files, no locking is necessary */
+	if(!can_dfsa_file(fd))
+	{
+		p->mosix.dupdates |= DFSA_UPDUSED;
+		return;
+	}
+	p->mosix.dupdates |= DFSA_UPDOPEN;
+	f = files->fd[fd];
+	if((n = file_count(f)) > 1)
+	{
+		/* must find all DUPs: */
+		register int i, l, li;
+		struct file **dups = files->fd;
+		unsigned long *bits = files->open_fds->fds_bits;
+		int lim = files->max_fds, llim;
+
+		if(lim > files->max_fdset)
+			lim = files->max_fdset;
+		llim = (lim + BITS_PER_LONG - 1) / BITS_PER_LONG;
+		for(i = l = 0 ; l < llim ; l++)
+		if(*bits++)
+		{
+			li = i + BITS_PER_LONG;
+			if(li > lim)
+				li = lim;
+			for(; i < li ; i++)
+			if(dups[i] == f)
+			{
+				if(i >= files->maxopened)
+					files->maxopened = i + 1;
+				FD_SET(i, files->opened);
+				FD_CLR(i, files->modified);
+				if(--n == 0)
+					return;
+			}
+		}
+		else
+			i += BITS_PER_LONG;
+	}
+	else
+	{
+		if(fd >= files->maxopened)
+			files->maxopened = fd + 1;
+		FD_SET(fd, files->opened);
+		FD_CLR(fd, files->modified);
+	}
+}
+
+void
+dfsa_touch_file(int fd)
+{
+	struct task_struct *p = current;
+	register struct files_struct *files = p->files;
+	struct file *f;
+	int n;
+
+	if(atomic_read(&files->users) > 1)
+	{
+		tell_process(p, DREQ_NOTUPTODATE);
+		return;
+	}
+	/* since nobody shares our files, no locking is necessary */
+	if(!can_dfsa_file(fd))
+		return;
+	p->mosix.dupdates |= DFSA_UPDMODS;
+	f = files->fd[fd];
+	if((n = file_count(f)) > 1)
+	{
+		/* must find all DUPs: */
+		register int i, l, li;
+		struct file **dups = files->fd;
+		unsigned long *bits = files->open_fds->fds_bits;
+		int lim = files->max_fds;
+		int llim;
+
+		if(lim > files->max_fdset)
+			lim = files->max_fdset;
+		llim = (lim + BITS_PER_LONG - 1) / BITS_PER_LONG;
+		for(i = l = 0 ; l < llim ; l++)
+		if(*bits++)
+		{
+			li = i + BITS_PER_LONG;
+			if(li > lim)
+				li = lim;
+			for(; i < li ; i++)
+			if(dups[i] == f)
+			{
+				if(FD_ISSET(i, files->opened))
+					continue;
+				if(i >= files->maxmod)
+					files->maxmod = i + 1;
+				FD_SET(i, files->modified);
+				if(--n == 0)
+					return;
+			}
+		}
+		else
+			i += BITS_PER_LONG;
+	}
+	else
+	{
+		if(FD_ISSET(fd, files->opened))
+			return;
+		if(fd >= files->maxmod)
+			files->maxmod = fd + 1;
+		FD_SET(fd, files->modified);
+	}
+}
+
+/*
+ * callers to "can_dfsa_file" must first make sure (perhaps with "CAN_DFSA")
+ * that their files_struct is not shared with clones:
+ * hence, neither the caller nor "can_dfsa_file" need to lock the files
+ * (which could deadlock the mosix-lock)
+ */
+int
+can_dfsa_file(int fd)
+{
+	register int i, l, li;
+	struct file *file = fcheck(fd);
+	struct vfsmount *mnt;
+	int fs, mode, n;
+
+	if(!file)
+		return(0);
+	mnt = file->f_vfsmnt;
+	lock_mosix();
+	if(current->mosix.dflags & DREMOTE)
+	{
+		/* well, since it is open, it MUST be a DFSA file! */
+		if(!(fs = mnt->mnt_dfsaprev) && !(fs = mnt->mnt_dfsano))
+			panic("remote loose DFSA fd");
+		unlock_mosix();
+		return(fs);
+	}
+	if(!(fs = mnt->mnt_dfsano) || dfsa_being_cancelled[fs-1])
+	{
+		unlock_mosix();
+		return(0);
+	}
+	unlock_mosix();
+	mode = file->f_dentry->d_inode->i_mode;
+	if(!S_ISREG(mode) && !S_ISDIR(mode) && !S_ISLNK(mode))
+		return(0);
+	n = file_count(file);
+	if(n != 1)
+	{
+		/* Are all links merily our own DUPs? */
+		struct file **files = current->files->fd;
+		unsigned long *bits = current->files->open_fds->fds_bits;
+		int lim = current->files->max_fds;
+		int llim;
+
+		if(lim > current->files->max_fdset)
+			lim = current->files->max_fdset;
+		llim = (lim + BITS_PER_LONG - 1) / BITS_PER_LONG;
+		for(i = l = 0 ; l < llim ; l++)
+		if(*bits++)
+		{
+			li = i + BITS_PER_LONG;
+			if(li > lim)
+				li = lim;
+			for(; i < li ; i++)
+			if(files[i] == file && --n == 0)
+				return(fs);
+		}
+		else
+			i += BITS_PER_LONG;
+		return(0);
+	}
+	return(fs);
+}
+
+void
+dfsa_tinit(void)
+{
+	struct task_struct *p = current;
+	struct files_struct *files = p->files;
+
+	CLEAR_ALL(files, closed);
+	files->maxclosed = 0;
+	CLEAR_ALL(files, modified);
+	files->maxmod = 0;
+	p->mosix.dupdates = 0;
+	p->fs->pwd_changed = 0;
+	p->mosix.ttab = NULL;
+}
+
+/*
+ * Is it OK to accept and open a file/directory opened on the other side?
+ * A DEPUTY must always accept.
+ * A REMOTE is more reserved.
+ */
+int
+ok_to_accept_in_dfsa(int dfsano)
+{
+	struct task_struct *p = current;
+	struct vfsmount *mnt;
+	struct dfsatab *tab;
+	struct dfsdef *def;
+	unsigned int i;
+
+	MOSIX_LOCKED;
+	if(dfsano < 1 || dfsano > MAXDFSAFS || !(mnt = dfsa_mounts[dfsano-1]))
+		return(0);
+	if(!(p->mosix.dflags & DREMOTE))
+		return(1);
+	if(dfsa_disabled)
+		return(0);
+	if(!(tab = p->mosix.ttab))
+		return(0);
+	if(dfsa_being_cancelled[dfsano-1])
+		return(0);
+	if(mnt->mnt_dfsaprev)
+		return(0);
+	for(def = tab->dfsdef , i = 0 ; i < tab->ndefs ; i++ , def++)
+	if(def->defno == dfsano)
+		return(1);
+	return(0);
+}
+
+void
+reconstruct(int dfsano, void *info, int infolen, struct vfsmount **mnt,
+							struct dentry **dp)
+{
+	char comma;
+
+	lock_mosix();
+	if(!ok_to_accept_in_dfsa(dfsano))
+	{
+		unlock_mosix();
+		goto bad;
+	}
+	*mnt = mntget(dfsa_mounts[dfsano-1]);
+	unlock_mosix();
+	*dp = (*mnt)->mnt_sb->s_op->reconstruct(*mnt, info, infolen);
+	if(*dp)
+		return;
+	mntput(*mnt);
+	bad:
+	if(current->mosix.dflags & DREMOTE)
+	{
+		*mnt = NULL;
+		*dp = NULL;
+		return;
+	}
+	printk("%s: Failed to reopen DFSA file (dfsano=%d, info",
+						desc_mostask(NULL), dfsano);
+	comma = '=';
+	while(infolen >= sizeof(int))
+	{
+		printk("%c%X", comma, *((int *)info++));
+		infolen -= sizeof(int);
+		comma=',';
+	}
+	printk(")\n");
+	*mnt = mntget(current->fs->rootmnt);
+	*dp = dget(bad_deputy_dfsaentry);
+}
+
+void
+dfsa_file_install(int fd, mode_t mode, loff_t pos, unsigned int flags,
+					int dfsano, void *info, int infolen)
+{
+	struct vfsmount *mnt;
+	struct dentry *dp;
+	register struct file *fp;
+	register struct inode *ip;
+	struct files_struct *files = current->files;
+	int failure;
+
+	reconstruct(dfsano, info, infolen, &mnt, &dp);
+	if(!dp)	/* (can only happen on REMOTE) */
+		return;
+	if(atomic_read(&files->users) != 1)
+		panic("dfsa_file_install: sharing");
+	write_lock(&files->file_lock);
+	failure = (fd >= files->max_fdset && expand_fdset(files, fd));
+	write_unlock(&files->file_lock);
+	if(failure)
+		goto bad1;
+	if((fp = get_empty_filp()))
+	{
+		fp->f_dentry = dp;
+		fp->f_vfsmnt = mnt;
+		ip = dp->d_inode;
+		fp->f_op = fops_get(ip->i_fop);
+		if((fp->f_op && fp->f_op->open && fp->f_op->open(ip, fp)))
+		{
+			fput(fp);
+			goto bad;
+		}
+		flags &= ~O_NOWRITEACCESS;
+		if(mode & FMODE_WRITE)
+		{
+			if(get_write_access(ip))
+				flags |= O_NOWRITEACCESS;
+		}
+		fp->f_flags = flags;
+		fp->f_pos = pos;
+		fp->f_mode = mode;
+		fp->f_reada = 0;
+		write_lock(&files->file_lock);
+		files->fd[fd] = fp;
+		FD_SET(fd, files->open_fds);
+		FD_CLR(fd, files->close_on_exec);
+		write_unlock(&files->file_lock);
+		/* the following "should not" happen, but it could due to an
+		 * inconsistency in the file-system - at least we must now
+		 * instruct our REMOTE to stop using that file!
+		 */
+		if((current->mosix.dflags & DDEPUTY) && !can_dfsa_file(fd))
+			dfsa_close_file(fd);
+	}
+	else
+	{
+		bad1:
+		dput(dp);
+		mntput(mnt);
+		bad:
+		if(!(current->mosix.dflags & DREMOTE))
+			printk("%s: Failed to allocate DFSA file for reopen\n",
+				desc_mostask(NULL));
+	}
+}
+
+void
+deputy_resync_dfsa(void)
+{
+	register struct task_struct *p = current;
+	char *update;
+	int sz;
+
+	again:
+	p->mosix.dupdates |= DFSA_UPDATE;
+	clear_dfsasync();
+	if(CAN_DFSA(p) && (update = deputy_pack_dfsa_changes(&sz)))
+	{
+		if(deputy_request(DEP_DFSA_CHANGES, &sz, sizeof(sz),
+							update, sz, 0, NULL, 0))
+			deputy_communication_failed();
+		kfree(update);
+		if(process_told(p, DREQ_DFSASYNC)) /* a new one (race) */
+			goto again;
+	}
+	else if(deputy_request(DEP_DFSA_CLEAR, NULL, 0, NULL, 0, 0, NULL, 0))
+		deputy_communication_failed();
+}
+
+void
+remote_clear_dfsa(void)
+{
+	register struct task_struct *p = current;
+	extern void close_files(struct files_struct *);
+
+	if(p->mosix.ttab)
+	{
+		kfree(p->mosix.ttab);
+		p->mosix.ttab = NULL;
+	}
+	close_files(p->files);
+	CLEAR_ALL(p->files, open_fds);
+	p->files->next_fd = 0;
+	if(p->fs->pwd)
+	{
+		dput(p->fs->pwd);
+		p->fs->pwd = NULL;
+		mntput(p->fs->pwdmnt);
+		p->fs->pwdmnt = NULL;
+	}
+}
+
+int
+dfsa_optimized_read(struct file *f, loff_t off, unsigned long addr,
+							unsigned long len)
+{
+	struct task_struct *p = current;
+	struct read_yourself_h r;
+	struct vfsmount *mnt;
+	char data[MAX_IDENT_RECORD_LEN];
+	int result;
+
+	if(!(p->mosix.dflags & DDEPUTY) || !CAN_DFSA(p))
+		goto read;
+	mnt = f->f_vfsmnt;
+	lock_mosix();
+	if(!(r.dfsano = mnt->mnt_dfsano) || dfsa_being_cancelled[r.dfsano-1])
+	{
+		unlock_mosix();
+		goto read;
+	}
+	unlock_mosix();
+	if(!(r.infolen = mnt->mnt_sb->s_op->identify(f->f_dentry, data)))
+		goto read;
+	r.off = off;
+	r.addr = addr;
+	r.len = len;
+	if(deputy_request(DEP_READ_YOURSELF, &r, sizeof(r), data, r.infolen, 0,
+		(void **)&result, -sizeof(result)))
+	{
+		deputy_communication_failed();
+		return(-EIO);
+	}
+	if(result == -ENOENT)
+	{
+		read:
+		return(f->f_op->read(f, (char *)addr, len, &off));
+	}
+	return(result);
+}
+
+int
+remote_read_yourself(struct read_yourself_h *r)
+{
+	int result = -ENOENT;
+	char data[MAX_IDENT_RECORD_LEN];
+	struct dentry *dp;
+	struct vfsmount *mnt;
+	struct file file;
+	struct inode *ip;
+
+	if(r->infolen > MAX_IDENT_RECORD_LEN ||
+		verify_area(VERIFY_WRITE, (char *)r->addr, r->len))
+	{
+		comm_flushdata(COMM_ALLDATA);
+		goto reply;
+	}
+	if(comm_copydata(data, r->infolen, 0))
+		goto reply;
+	reconstruct(r->dfsano, data, r->infolen, &mnt, &dp);
+	if(!dp)
+		goto reply;
+	ip = dp->d_inode;
+	if(ip->i_fop && ip->i_fop->read && !init_private_file(&file, dp, 1))
+	{
+		result = file.f_op->read(&file, (char *)r->addr, r->len,
+								&r->off);
+		if(file.f_op->release)
+			file.f_op->release(ip, &file);
+	}
+	dput(dp);
+	mntput(mnt);
+	reply:
+	comm_free(r);
+	result = comm_send(DEP_READ_YOURSELF|REPLY, &result, sizeof(int),
+								NULL, 0, 0);
+	return(result);
+}
+
+int
+enter_remote_dfsa_mode(void)
+{
+	struct task_struct *p = current;
+
+	if(!p->mosix.ttab)
+		return(0);
+	spin_lock_irq(&runqueue_lock);	/* ensures DREQ_EXITDFSA not lost */
+	p->mosix.dflags |= DREMOTEDFSA;
+	spin_unlock_irq(&runqueue_lock);
+	if(remote_deputy_has_something_for_us(p) ||
+		remote_need_while_asleep(p) ||
+		(process_told(p, (DREQ_DFSASYNC|DREQ_NOTUPTODATE))) ||
+		(p->mosix.dflags & DFAKESIGNAL))
+	{
+		leave_remote_dfsa_mode();
+		return(0);
+	}
+	return(1);
+}
+
+void
+leave_remote_dfsa_mode(void)
+{
+	register struct task_struct *p = current;
+
+	spin_lock_irq(&runqueue_lock);	/* ensures no new "DREQ_EXITDFSA" */
+	p->mosix.dflags &= ~(DREMOTEDFSA|DFAKESIGNAL);
+	spin_unlock_irq(&runqueue_lock);
+	process_ack(p, DREQ_EXITDFSA);
+	spin_lock_irq(&p->sigmask_lock);
+	p->sigpending = 0;
+	spin_unlock_irq(&p->sigmask_lock);
+}
+
+void
+dfsa_syscall_on_file(int fd, int touching)
+{
+	register struct task_struct *p = current;
+	static unsigned char rand;
+
+	if(!(p->mosix.dflags & (DDEPUTY|DREMOTE)) && CAN_DFSA(p) &&
+				(fd >= p->files->max_fds || can_dfsa_file(fd)))
+		p->mosix.dflags |= DSTATSDOWN;
+
+	/* consider a remote process that with regard to this file only runs a
+	 * combination of fstat(), fcntl(F_GETFL), fchdir(), fchmod(), fchown(),
+	 * fsync() and ftrunc() - but does lots of the above: if its parent
+	 * initially held the file open, but not any more, there is no other
+	 * way that the son will become aware of the fact that it may now do
+	 * all those things remotely.  Adding a file-flag on close is not very
+	 * helpful because a chain of relatives may be constantly closing this
+	 * file (or simply exiting).  On the other hand, running CAN_DFSA +
+	 * can_dfsa_file + dfsa_touch_file (including its communication
+	 * overhead) is expensive.
+	 * The compromise is to run them at random, once in about 256 times,
+	 * and eventually the process will come to know.
+	 */
+	if(touching || ((p->mosix.dflags & DDEPUTY) && !rand++ &&
+		CAN_DFSA(p) && can_dfsa_file(fd)))
+		dfsa_touch_file(fd);
+}
+
+void
+dfsa_exit(void)
+{
+	struct task_struct *p = current;
+
+	if(process_told(p, DREQ_DFSASYNC))
+		clear_dfsasync();
+	if(p->mosix.ttab)
+	{
+		kfree(p->mosix.ttab);
+		p->mosix.ttab = NULL;
+	}
+}
+
+/*** PACKING/UNPACKING UPDATES SECTION ***/
+
+enum
+{
+	/* general info: */
+	REC_CREDITS, REC_UMASK, REC_SELECT, REC_DFSATAB,
+	/* current directory */
+	REC_CDIR,
+	/* file table */
+	REC_MAX, REC_USED,
+	/* individual files */
+	REC_CLOSED, REC_NONDFSA, REC_FILE, REC_MOD, REC_DUP
+};
+
+struct credits_rec
+{
+	uid_t uid, euid, suid, fsuid;
+	gid_t gid, egid, sgid, fsgid;
+	int ngroups;
+	gid_t groups[NGROUPS];
+};
+
+/* the following is defined even if MFS is not configured,
+ * because it may possibly be configured by the peer node! */
+struct select_rec
+{
+	int selected;
+	int lastexec;
+	int lastmagic;
+};
+
+struct cdir_rec
+{
+	int dfsano;
+	int infolen;
+};
+
+struct max_rec
+{
+	int max_fds;
+	int max_fdset;
+};
+
+struct file_rec
+{
+	short fd;
+	mode_t mode;
+	loff_t pos;
+	unsigned int flags;
+	int dfsano;
+	int infolen;
+};
+
+struct mod_rec
+{
+	short fd;
+	mode_t mode;
+	loff_t pos;
+	unsigned int flags;
+};
+
+struct dup_rec
+{
+	short fd;
+	short orig;
+};
+
+static char *
+add_changes_record(char *old, char type, void *add, int addlen)
+{
+	char *rec;
+	int sz, minsz;
+
+	again:
+	if(old)
+	{
+		minsz = ((int *)old)[1] + sizeof(type) + addlen;
+		if(((int *)old)[0] < minsz)
+		{
+			sz = 2 * minsz;
+			if((sz & PAGE_MASK) >= minsz)
+				sz &= PAGE_MASK;
+			if(!(rec = kmalloc(sz, GFP_KERNEL)))
+			{
+				sz = minsz;
+				if(!(rec = kmalloc(sz, GFP_KERNEL)))
+				{
+					kfree(old);
+					return(NULL);
+				}
+			}
+			memcpy(rec, old, ((int *)old)[1]);
+			((int *)rec)[0] = sz;
+			kfree(old);
+			old = rec;
+			if(type == REC_DFSATAB)/* make sure it is still valid */
+			{
+				if(addlen < dfsatab->len)
+					goto again;
+				add = dfsatab;
+				addlen = dfsatab->len;
+			}
+		}
+		old[((int *)old)[1]] = type;
+		memcpy(old+((int *)old)[1] + sizeof(type), (char *)add, addlen);
+		((int *)old)[1] += addlen + sizeof(type);
+		return(old);
+	}
+	else
+	{
+		minsz = 2 * sizeof(int) + sizeof(type) + addlen;
+		sz = 2 * sizeof(int) + 3 * (addlen + sizeof(type));
+		if((sz & PAGE_MASK) >= minsz)
+			sz &= PAGE_MASK;
+		if(!(rec = kmalloc(sz, GFP_KERNEL)))
+		{
+			sz = minsz;
+			if(!(rec = kmalloc(sz, GFP_KERNEL)))
+				return(NULL);
+		}
+		((int *)rec)[0] = sz;
+		if(type == REC_DFSATAB)	/* make sure it is still valid */
+		{
+			if(addlen < dfsatab->len)
+			{
+				kfree(rec);
+				goto again;
+			}
+			add = dfsatab;
+			addlen = dfsatab->len;
+		}
+		((int *)rec)[1] = 2 * sizeof(int) + sizeof(type) + addlen;
+		rec[2*sizeof(int)] = type;
+		memcpy(rec+2*sizeof(int) + sizeof(type), (char *)add, addlen);
+		return(rec);
+	}
+}
+
+static void *
+get_record(char *buf, int *type)
+{
+	int pos = ((int *)buf)[0];
+	int tot = ((int *)buf)[1];
+	void *ret;
+
+	if(pos == 0)		/* "all done" mark */
+	{
+		all_done:
+		kfree(buf);
+		return(NULL);
+	}
+	if(pos >= tot)		/* first call */
+		pos = 2 * sizeof(int);
+	*type = buf[pos++];
+	ret = buf + pos;
+	switch(*type)
+	{
+	case REC_CREDITS:
+		pos += sizeof(struct credits_rec);
+		break;
+	case REC_UMASK:
+		pos += sizeof(int);
+		break;
+	case REC_SELECT:
+		pos += sizeof(struct select_rec);
+		break;
+	case REC_DFSATAB:
+		pos += ((struct dfsatab *)ret)->len;
+		break;
+	case REC_CDIR:
+		pos += sizeof(struct cdir_rec) +
+			((struct cdir_rec *)ret)->infolen;
+		break;
+	case REC_MAX:
+		pos += sizeof(struct max_rec);
+		break;
+	case REC_CLOSED:
+	case REC_NONDFSA:
+		pos += sizeof(int);
+		break;
+	case REC_FILE:
+		pos += sizeof(struct file_rec) +
+			((struct file_rec *)ret)->infolen;
+		break;
+	case REC_MOD:
+		pos += sizeof(struct mod_rec);
+		break;
+	case REC_DUP:
+		pos += sizeof(struct dup_rec);
+		break;
+	case REC_USED:
+		if((current->mosix.dflags & DDEPUTY) ||
+		   current->mosix.ttab)
+			pos += current->files->max_fdset / 8;
+		else
+			/* we can't be sure about size - and it does not matter
+			   anyway: an expansion must have failed earlier */
+			goto all_done;
+		break;
+	default:
+		printk("buf = 0x%x, type=%d\n", (int)buf, *type);
+		panic("get_record");
+	}
+	((int *)buf)[0] = (pos >= tot) ? 0 : pos;
+	return(ret);
+}
+
+int
+add_closed_files(char **bufp)
+{
+	int i;
+	unsigned long bit = 1;
+	register struct files_struct *files = current->files;
+	unsigned long *mask = files->closed->fds_bits;
+	unsigned long bits = *mask;
+	char *buf = *bufp;
+
+	*mask = 0;
+	for(i = 0 ; i < files->maxclosed ; i++)
+	{
+		if((bits & bit) && !(buf =
+			add_changes_record(buf, REC_CLOSED, &i, sizeof(i))))
+		{
+			*bufp = NULL;
+			return(-ENOMEM);
+		}
+		bits &= ~bit;
+		if(bits)
+			bit <<= 1;
+		else
+		{
+			i = (i + __NFDBITS) & ~(__NFDBITS-1);
+			bit = 1;
+			while(1)
+			{
+				if(i >= files->maxclosed - 1)
+					break;
+				bits = *(++mask);
+				*mask = 0;
+				if(bits)
+					break;
+				i += __NFDBITS;
+			}
+		}
+	}
+	files->maxclosed = 0;
+	*bufp = buf;
+	return(0);
+}
+
+int
+add_opened_files(char **bufp)
+{
+	int i, j, dfsano;
+	struct task_struct *p = current;
+	register struct files_struct *files = p->files;
+	unsigned long *mask = files->opened->fds_bits;
+	unsigned long bits = *mask;
+	unsigned long bit = 1;
+	struct
+	{
+		struct file_rec f;
+		char info[MAX_IDENT_RECORD_LEN];
+	} fplus;
+	struct dup_rec d;
+	struct file **fds = files->fd;
+	char *buf = *bufp;
+	struct dentry *dp;
+
+	*mask = 0;
+	for(i = 0 ; i < files->maxopened ; i++)
+	{
+		if(!(bits & bit))
+			goto file_done;
+		if(!fds[i])
+		{
+			if(p->mosix.dflags & DREMOTE)
+			/* tell DEPUTY that REMOTE needs full file-info */
+				goto non_dfsa;
+			goto file_done;
+		}
+		if(!(dfsano = can_dfsa_file(i)))
+		{
+			non_dfsa:
+			if(!(buf = add_changes_record(buf, REC_NONDFSA, &i,
+								sizeof(i))))
+			{
+				fail:
+				return(-ENOMEM);
+			}
+			goto file_done;
+		}
+		if(file_count(fds[i]) > 1)
+		for(j = 0 ; j < i ; j++)
+		if(fds[j] == fds[i])
+		{
+			d.fd = i;
+			d.orig = j;
+			buf = add_changes_record(buf, REC_DUP, &d, sizeof(d));
+			if(!buf)
+				goto fail;
+			goto file_done;
+		}
+		dp = fds[i]->f_dentry;
+		fplus.f.infolen = fds[i]->f_vfsmnt->mnt_sb->s_op->identify(
+						fds[i]->f_dentry, &fplus.info);
+		if(!fplus.f.infolen)
+			goto fail;
+		fplus.f.fd = i;
+		fplus.f.mode = fds[i]->f_mode;
+		fplus.f.pos = fds[i]->f_pos;
+		fplus.f.flags = fds[i]->f_flags;
+		fplus.f.dfsano = dfsano;
+		if(!(buf = add_changes_record(buf, REC_FILE, &fplus,
+				sizeof(struct file_rec) + fplus.f.infolen)))
+			goto fail;
+		file_done:
+		bits &= ~bit;
+		if(bits)
+			bit <<= 1;
+		else
+		{
+			i = (i + __NFDBITS) & ~(__NFDBITS-1);
+			bit = 1;
+			while(1)
+			{
+				if(i >= files->maxmod - 1)
+					break;
+				bits = *(++mask);
+				*mask = 0;
+				if(bits)
+					break;
+				i += __NFDBITS;
+			}
+		}
+	}
+	files->maxmod = 0;
+	*bufp = buf;
+	return(0);
+}
+
+int
+add_modified_files(char **bufp)
+{
+	int i;
+	unsigned int j;
+	struct task_struct *p = current;
+	register struct files_struct *files = p->files;
+	unsigned long *mask = files->modified->fds_bits;
+	unsigned long bits = *mask;
+	unsigned long bit = 1;
+	struct mod_rec m;
+	struct file **fds = files->fd;
+	char *buf = *bufp;
+
+	*mask = 0;
+	for(i = 0 ; i < files->maxmod ; i++)
+	{
+		if(!(bits & bit) || !fds[i])
+			goto file_done;
+		if(!can_dfsa_file(i))
+		{
+			if(!(buf = add_changes_record(buf, REC_NONDFSA,
+							&i, sizeof(i))))
+			{
+				fail:
+				return(-ENOMEM);
+			}
+			goto file_done;
+		}
+		if(file_count(fds[i]) > 1)
+		for(j = 0 ; j < i ; j++)
+		if(fds[j] == fds[i])	/* touched one - touched all! */
+			goto file_done;
+		m.fd = i;
+		m.mode = fds[i]->f_mode;
+		m.pos = fds[i]->f_pos;
+		m.flags = fds[i]->f_flags;
+		if(!(buf = add_changes_record(buf, REC_MOD, &m, sizeof(m))))
+			goto fail;
+		file_done:
+		bits &= ~bit;
+		if(bits)
+			bit <<= 1;
+		else
+		{
+			i = (i + __NFDBITS) & ~(__NFDBITS-1);
+			bit = 1;
+			while(1)
+			{
+				if(i >= files->maxmod - 1)
+					break;
+				bits = *(++mask);
+				*mask = 0;
+				if(bits)
+					break;
+				i += __NFDBITS;
+			}
+		}
+	}
+	files->maxmod = 0;
+	*bufp = buf;
+	return(0);
+}
+
+char *
+deputy_pack_dfsa_changes(int *retsz)
+{
+	char *buf = NULL;
+	register struct task_struct *p = current;
+	register struct files_struct *files = p->files;
+	register unsigned int i;
+	register uint32_t updates;
+
+	if(files->count_dropped_to_one || current->fs->count_dropped_to_one ||
+		(process_told(p, DREQ_NOTUPTODATE)))
+	{
+		/* so this is the first time after a while that CAN_DFSA */
+		/* was TRUE: changes might have occured by our "partners" */
+		/* so we must assume that our REMOTE does not know anything */
+		/* (or its knowledge is obsolete) */
+		
+		files->count_dropped_to_one = 0;
+		p->fs->count_dropped_to_one = 0;
+		process_ack(p, DREQ_NOTUPTODATE);
+		p->mosix.dupdates |= DFSA_UPDATE;
+	}
+	if(!(updates = (p->mosix.dupdates & DFSA_UPDATE)))
+		goto out;
+	if(updates & DFSA_UPDCRED)
+	{
+		struct credits_rec c;
+
+		c.uid = p->uid;
+		c.euid = p->euid;
+		c.suid = p->suid;
+		c.fsuid = p->fsuid;
+		c.gid = p->gid;
+		c.egid = p->egid;
+		c.sgid = p->sgid;
+		c.fsgid = p->fsgid;
+		/* dirty compatibility-keeper: */
+		c.ngroups = p->ngroups;
+		for(i = 0 ; i < c.ngroups ; i++)
+			c.groups[i] = p->groups[i];
+		if(!(buf = add_changes_record(buf, REC_CREDITS, &c, sizeof(c))))
+		{
+			fail:
+			*retsz = -ENOMEM;
+			return(NULL);
+		}
+	}
+	if(updates & DFSA_UPDUMASK)
+	{
+		if(!(buf = add_changes_record(buf, REC_UMASK, &p->fs->umask,
+								sizeof(int))))
+			goto fail;
+	}
+#ifdef CONFIG_MOSIX_FS
+	if(updates & DFSA_UPDSEL)
+	{
+		struct select_rec s;
+
+		s.selected = p->mosix.selected;
+		s.lastexec = p->mosix.lastexec;
+		s.lastmagic = p->mosix.lastmagic;
+		if(!(buf = add_changes_record(buf, REC_SELECT, &s, sizeof(s))))
+			goto fail;
+	}
+#endif /* CONFIG_MOSIX_FS */
+	if(updates & DFSA_UPDTABLE)
+	{
+		if(!(buf = add_changes_record(buf, REC_DFSATAB, dfsatab,
+								dfsatab->len)))
+			goto fail;
+		/* this causes the REMOTE to flush all it knows, so: */
+		updates |= (DFSA_UPDCDIR|DFSA_UPDMAX|DFSA_UPDMODS|DFSA_UPDUSED);
+		memcpy(files->modified, files->open_fds, files->max_fdset / 8);
+		files->maxmod = (files->max_fds > files->max_fdset) ?
+					files->max_fdset : files->max_fds;
+		updates &= ~DFSA_UPDCLOSE;	/* all will be closed anyway */
+		CLEAR_ALL(files, closed);
+		files->maxclosed = 0;
+	}
+	if(updates & DFSA_UPDCDIR)
+	{
+		struct
+		{
+			struct cdir_rec c;
+			char info[MAX_IDENT_RECORD_LEN];
+		} cplus;
+		struct vfsmount *mnt = p->fs->pwdmnt;
+
+		if((cplus.c.dfsano = mnt->mnt_dfsano))
+			cplus.c.infolen = mnt->mnt_sb->s_op->identify(
+							p->fs->pwd, cplus.info);
+		else
+			cplus.c.infolen = 0;
+		buf = add_changes_record(buf, REC_CDIR, &cplus,
+					sizeof(cplus.c) + cplus.c.infolen);
+		if(!buf)
+			goto fail;
+	}
+	if(updates & DFSA_UPDMAX)
+	{
+		struct max_rec m;
+
+		m.max_fds = files->max_fds;
+		m.max_fdset = files->max_fdset;
+		if(!(buf = add_changes_record(buf, REC_MAX, &m, sizeof(m))))
+			goto fail;
+	}
+	if(updates & DFSA_UPDCLOSE)
+	{
+		if(add_closed_files(&buf))
+			goto fail;
+	}
+	if(updates & DFSA_UPDOPEN)
+	{
+		if(add_opened_files(&buf))
+			goto fail;
+	}
+	if(updates & DFSA_UPDMODS)
+	{
+		if(add_modified_files(&buf))
+			goto fail;
+	}
+	if(updates & DFSA_UPDUSED)
+	{
+		if(!(buf = add_changes_record(buf, REC_USED,
+			files->open_fds, files->max_fdset / 8)))
+			goto fail;
+	}
+	current->mosix.dupdates &= ~DFSA_UPDATE;
+	out:
+	*retsz = buf ? ((int *)buf)[1] : 0;
+	return(buf);
+}
+
+static void
+close_remote_fd(int fd, int code)
+{
+	register struct files_struct *files = current->files;
+	register struct file *fp = files->fd[fd];
+
+	/* no locking is required, since files->users is always 1 */
+	if(fp)
+	{
+		files->fd[fd] = NULL;
+		filp_close(fp, files);
+	}
+	if(code == REC_CLOSED)
+	{
+		FD_CLR(fd, files->open_fds);
+		if(fd < files->next_fd)
+			files->next_fd = fd;
+	}
+	else
+		FD_SET(fd, files->open_fds);
+}
+
+void
+remote_unpack_dfsa_changes(char *changes)
+{
+	int type;
+	void *rec;
+	register struct task_struct *p = current;
+	register struct files_struct *files = p->files;
+	register int i, j;
+	int dfsano;
+	struct file *fp;
+	struct dfsatab *tab;
+	mode_t mode;
+	loff_t pos;
+	unsigned int flags;
+	void *info;
+	int infolen;
+	gid_t *grp;
+
+	deeper_sleep();
+	while((rec = get_record(changes, &type)))
+		switch(type)
+		{
+		case REC_CREDITS:
+			p->uid = ((struct credits_rec *)rec)->uid;
+			p->euid = ((struct credits_rec *)rec)->euid;
+			p->suid = ((struct credits_rec *)rec)->suid;
+			p->fsuid = ((struct credits_rec *)rec)->fsuid;
+			p->gid = ((struct credits_rec *)rec)->gid;
+			p->egid = ((struct credits_rec *)rec)->egid;
+			p->sgid = ((struct credits_rec *)rec)->sgid;
+			p->fsgid = ((struct credits_rec *)rec)->fsgid;
+			p->ngroups = ((struct credits_rec *)rec)->ngroups;
+			grp = ((struct credits_rec *)rec)->groups;
+			for(i = 0 ; i < p->ngroups ; i++)
+				p->groups[i] = *grp++;
+			break;
+		case REC_UMASK:
+			p->fs->umask = *((int *)rec);
+			break;
+		case REC_SELECT:
+#ifdef CONFIG_MOSIX_FS
+			p->mosix.selected =
+				((struct select_rec *)rec)->selected;
+			p->mosix.lastexec =
+				((struct select_rec *)rec)->lastexec;
+			p->mosix.lastmagic =
+				((struct select_rec *)rec)->lastmagic;
+#endif /* CONFIG_MOSIX_FS */
+			break;
+		case REC_DFSATAB:
+			remote_clear_dfsa();
+			i = ((struct dfsatab *)rec)->len;
+			if(!(tab = kmalloc(i, GFP_KERNEL)))
+				break;
+			memcpy((caddr_t)tab, (caddr_t)rec, i);
+			dfsa_adapt(tab);
+			p->mosix.ttab = tab;
+			process_ack(p, DREQ_NOTUPTODATE);
+			break;
+		case REC_CDIR:
+			if(p->fs->pwd)
+			{
+				dput(p->fs->pwd);
+				p->fs->pwd = NULL;
+				mntput(p->fs->pwdmnt);
+				p->fs->pwdmnt = NULL;
+			}
+			if(!(dfsano = ((struct cdir_rec *)rec)->dfsano))
+				break;
+			info = (void *)(((char *)rec)+sizeof(struct cdir_rec));
+			infolen = ((struct cdir_rec *)rec)->infolen;
+			reconstruct(dfsano, info, infolen, &p->fs->pwdmnt,
+				    &p->fs->pwd);
+			break;
+		case REC_MAX:
+			i = ((struct max_rec *)rec)->max_fdset;
+			j = ((struct max_rec *)rec)->max_fds;
+			write_lock(&files->file_lock);
+			i = ((i > files->max_fdset && expand_fdset(files, i-1))
+			     ||
+			     (j > files->max_fds && expand_fd_array(files, j-1)));
+			write_unlock(&files->file_lock);
+			if(i)
+			{
+				remote_clear_dfsa();
+				tell_process(p, DREQ_NOTUPTODATE);
+			}
+			break;
+		case REC_CLOSED:
+		case REC_NONDFSA:
+			if(current->mosix.ttab)
+				close_remote_fd(*((int *)rec), type);
+			break;
+		case REC_FILE:
+			if(!current->mosix.ttab)
+				break;
+			i = ((struct file_rec *)rec)->fd;
+			mode = ((struct file_rec *)rec)->mode;
+			pos = ((struct file_rec *)rec)->pos;
+			flags = ((struct file_rec *)rec)->flags;
+			if(p->files->fd[i])
+			{
+				close_remote_fd(i, REC_FILE);
+			}
+			dfsano = ((struct file_rec *)rec)->dfsano;
+			info = (void *)(((char *)rec)+sizeof(struct file_rec));
+			infolen = ((struct file_rec *)rec)->infolen;
+			dfsa_file_install(i, mode, pos, flags, dfsano, info,
+					  infolen);
+			/* even if we failed, file was still opened on DEPUTY */
+			FD_SET(i, files->open_fds);
+			break;
+		case REC_MOD:
+			if(!current->mosix.ttab)
+				break;
+			i = ((struct file_rec *)rec)->fd;
+			if(!(fp = p->files->fd[i]))
+			{
+				/* asking DEPUTY to send REC_FILE */
+				p->mosix.dupdates |= DFSA_UPDOPEN;
+				if(i >= files->maxopened)
+					files->maxopened = i + 1;
+				FD_SET(i, files->opened);
+				break;
+			}
+			mode = ((struct file_rec *)rec)->mode;
+			pos = ((struct file_rec *)rec)->pos;
+			flags = ((struct file_rec *)rec)->flags;
+			fp->f_mode = mode;
+			fp->f_pos = pos;
+			fp->f_flags = flags;
+			break;
+		case REC_DUP:
+			if(!current->mosix.ttab)
+				break;	/* previous expanding-failure */
+			i = ((struct dup_rec *)rec)->fd;
+			close_remote_fd(i, REC_DUP);
+			if((fp = files->fd[((struct dup_rec *)rec)->orig]))
+			{
+				get_file(fp);
+				current->files->fd[i] = fp;
+			}
+			break;
+		case REC_USED:
+			if(!current->mosix.ttab)
+				break;	/* previous expanding-failure */
+			memcpy((caddr_t)files->open_fds, (caddr_t)rec,
+			       files->max_fdset / 8);
+			break;
+		}
+	lighter_sleep();
+}
+
+char *
+remote_pack_dfsa_changes(int *retsz)
+{
+	char *buf = NULL;
+	register struct task_struct *p = current;
+	register uint32_t updates;
+
+	if(!(updates = (p->mosix.dupdates & DFSA_UPDATE)))
+		goto out;
+	/* NOTE: we do not allow max_fds or max_fdset to grow REMOTELY,
+	 * so we do not act on this flag here */
+#ifdef CONFIG_MOSIX_FS
+	if(updates & DFSA_UPDSEL)
+	{
+		struct select_rec s;
+
+		s.selected = p->mosix.selected;
+		s.lastexec = p->mosix.lastexec;
+		s.lastmagic = p->mosix.lastmagic;
+		if(!(buf = add_changes_record(buf, REC_SELECT, &s, sizeof(s))))
+			goto fail;
+	}
+#endif /* CONFIG_MOSIX_FS */
+	if((updates & DFSA_UPDCDIR) && p->fs->pwd)
+	{
+		struct
+		{
+			struct cdir_rec c;
+			char info[MAX_IDENT_RECORD_LEN];
+		} cplus;
+		struct vfsmount *mnt = p->fs->pwdmnt;
+
+		lock_mosix();
+		if(!(cplus.c.dfsano = mnt->mnt_dfsaprev ? : mnt->mnt_dfsano))
+			panic("REMOTE non-DFSA cdir");
+		unlock_mosix();
+		cplus.c.infolen = mnt->mnt_sb->s_op->identify(p->fs->pwd,
+								cplus.info);
+		buf = add_changes_record(buf, REC_CDIR, &cplus,
+					sizeof(cplus.c) + cplus.c.infolen);
+		if(!buf)
+			goto fail;
+	}
+	if(updates & DFSA_UPDCLOSE)
+	{
+		if(add_closed_files(&buf))
+		{
+			fail:
+			*retsz = -ENOMEM;
+			return(NULL);
+		}
+	}
+	if(updates & DFSA_UPDOPEN)
+	{
+		if(add_opened_files(&buf))
+			goto fail;
+	}
+	if(updates & DFSA_UPDMODS)
+	{
+		if(add_modified_files(&buf))
+			goto fail;
+	}
+	p->mosix.dupdates &= ~DFSA_UPDATE;
+	out:
+	*retsz = buf ? ((int *)buf)[1] : 0;
+	return(buf);
+}
+
+static void
+close_deputy_fd(int fd)
+{
+	register struct files_struct *files = current->files;
+	register struct file *fp;
+
+	/* files->users must be 1, but we lock against /proc/{mypid}/fd */
+	write_lock(&files->file_lock);
+	if((fp = files->fd[fd]))
+	{
+		files->fd[fd] = NULL;
+		FD_CLR(fd, files->open_fds);
+		FD_CLR(fd, files->close_on_exec);
+		if(fd < files->next_fd)
+			files->next_fd = fd;
+		filp_close(fp, files);
+	}
+	write_unlock(&files->file_lock);
+}
+
+void
+deputy_unpack_dfsa_changes(char *changes)
+{
+	int type;
+	void *rec;
+	register struct task_struct *p = current;
+	register struct files_struct *files = p->files;
+	register int i;
+	int dfsano;
+	struct file *fp;
+	void *info;
+	int infolen;
+	mode_t mode;
+	loff_t pos;
+	unsigned int flags;
+
+	deeper_sleep();
+	while((rec = get_record(changes, &type)))
+		switch(type)
+		{
+		case REC_SELECT:
+#ifdef CONFIG_MOSIX_FS
+			p->mosix.selected =
+				((struct select_rec *)rec)->selected;
+			p->mosix.lastexec =
+				((struct select_rec *)rec)->lastexec;
+			p->mosix.lastmagic =
+				((struct select_rec *)rec)->lastmagic;
+#endif /* CONFIG_MOSIX_FS */
+			break;
+		case REC_CDIR:
+			dfsano = ((struct cdir_rec *)rec)->dfsano;
+			info = (void *)(((char *)rec)+sizeof(struct cdir_rec));
+			infolen = ((struct cdir_rec *)rec)->infolen;
+			write_lock(&p->fs->lock);
+			dput(p->fs->pwd);
+			p->fs->pwd = NULL;
+			mntput(p->fs->pwdmnt);
+			p->fs->pwdmnt = NULL;
+			reconstruct(dfsano, info, infolen, &p->fs->pwdmnt,
+				    &p->fs->pwd);
+			write_unlock(&p->fs->lock);
+			break;
+		case REC_CLOSED:
+			i = *((int *)rec);
+			close_deputy_fd(i);
+			break;
+		case REC_FILE:
+			i = ((struct file_rec *)rec)->fd;
+			mode = ((struct file_rec *)rec)->mode;
+			pos = ((struct file_rec *)rec)->pos;
+			flags = ((struct file_rec *)rec)->flags;
+			if((fp = files->fd[i]))
+				/* only a change (or we would have to close first!) */
+			{
+				close_deputy_fd(i);
+			}
+			dfsano = ((struct file_rec *)rec)->dfsano;
+			info = (void *)(((char *)rec)+sizeof(struct file_rec));
+			infolen = ((struct file_rec *)rec)->infolen;
+			dfsa_file_install(i, mode, pos, flags, dfsano, info,
+					  infolen);
+			break;
+		case REC_NONDFSA:
+			/* this is a request for fuller info */
+			i = *((int *)rec);
+			p->mosix.dupdates |= DFSA_UPDOPEN;
+			if(i >= files->maxopened)
+				files->maxopened = i + 1;
+			FD_SET(i, files->opened);
+			FD_CLR(i, files->modified);
+			break;
+		case REC_MOD:
+			i = ((struct file_rec *)rec)->fd;
+			mode = ((struct file_rec *)rec)->mode;
+			pos = ((struct file_rec *)rec)->pos;
+			flags = ((struct file_rec *)rec)->flags;
+			if(!(fp = files->fd[i]))
+				break;
+			fp->f_mode = mode;
+			fp->f_pos = pos;
+			fp->f_flags = flags;
+			break;
+		case REC_DUP:
+			i = ((struct dup_rec *)rec)->fd;
+			close_deputy_fd(i);
+			if((fp = files->fd[((struct dup_rec *)rec)->orig]))
+			{
+				write_lock(&files->file_lock);
+				FD_SET(i, files->open_fds);
+				get_file(fp);
+				files->fd[i] = fp;
+				write_unlock(&files->file_lock);
+			}
+			else
+			{
+				printk("%s: DFSA told that FD #%d is a DUP "
+				       "of FD #%d... which is NULL\n",
+				       desc_mostask(NULL), i,
+				       ((struct dup_rec *)rec)->orig);
+				dfsa_file_install(i, 0, 0, 0, 0, NULL, 0);
+			}
+			break;
+		default:
+			printk("record type = %d\n", type);
+			panic("deputy_unpack_dfsa_changes");
+		}
+	lighter_sleep();
+}
+
+void
+dfsa_check_comm_send(int *type, char **result, int *reslen)
+{
+	register struct task_struct *p = current;
+	register struct mosix_task *m = &p->mosix;
+
+	if(*type & DFSA_NOUPDATE)
+	{
+		*result = NULL;
+		*reslen = 0;
+		return;
+	}
+	if((m->dflags & (DREMOTE|DPSYNC|DINCOMING)) == DREMOTE)
+	{
+		if((*result = remote_pack_dfsa_changes(reslen)))
+			*type |= COMM_MFDFSA;
+		if(!m->ttab || (process_told(p, DREQ_NOTUPTODATE)))
+			*type |= COMM_MFNODFSA;
+		return;
+	}
+	*result = NULL;
+	*reslen = 0;
+	if(!(*type & USERMODE))
+		return;
+	if(process_told(p, DREQ_DFSASYNC))
+		clear_dfsasync();
+	if(process_told(p, DREQ_NOTUPTODATE))
+		m->dupdates |= DFSA_UPDATE;
+	if(!(m->dupdates & DFSA_UPDATE))
+		return;
+	again:
+	if(!CAN_DFSA(p))
+		goto no_dfsa;
+	*result = deputy_pack_dfsa_changes(reslen);
+	if(process_told(p, DREQ_DFSASYNC))	/* a new one (race) */
+	{
+		clear_dfsasync();
+		m->dupdates |= DFSA_UPDATE;
+		if(*result)
+			kfree(*result);
+		goto again;
+	}
+	if(*result)
+	{
+		*type |= COMM_MFDFSA;
+		return;
+	}
+	if(*reslen == 0)
+		return;
+	no_dfsa:
+	*type |= COMM_MFNODFSA;
+	*reslen = 0;
+}
+
+void
+dfsa_comm_recv(int type, char *changes)
+{
+	register struct task_struct *p = current;
+	if(type & COMM_MFNODFSA)
+	{
+		if(p->mosix.dflags & DREMOTE)
+			remote_clear_dfsa();
+		tell_process(p, DREQ_NOTUPTODATE);
+	}
+	if(type & COMM_MFDFSA)
+	{
+		if(p->mosix.dflags & DREMOTE)
+			remote_unpack_dfsa_changes(changes);
+		else
+			deputy_unpack_dfsa_changes(changes);
+	}
+}
+
+static void printset(char *title, int max, fd_set *set)
+{
+	register int i;
+
+	printk("%s (max=%d): ", title, max);
+	for(i = 0 ; i < max ; i++)
+	if(FD_ISSET(i, set))
+		printk(" %d", i);
+	printk("\n");
+}
+
+void
+dfsa_dump(int pid)
+{
+	register struct task_struct *p = current;
+	register struct files_struct *files = p->files;
+	register unsigned int i;
+	register int fs;
+	struct file *f;
+
+	if(pid)
+	{
+		read_lock(&tasklist_lock);
+		for_each_task(p)
+		if(p->pid == pid || (int)p == pid)
+			break;
+		read_unlock(&tasklist_lock);
+		if(p == &init_task)
+		{
+			printk("Pid %d not found.\n", pid);
+			return;
+		}
+		files = p->files;
+	}
+	printk("%s : CAN_DFSA=%d\n", desc_mostask(&p->mosix), CAN_DFSA(p));
+	printk("Update flags:");
+	if(p->mosix.dupdates & DFSA_UPDCRED)
+		printk(" UPDCRED");
+	if(p->mosix.dupdates & DFSA_UPDSEL)
+		printk(" UPDSEL");
+	if(p->mosix.dupdates & DFSA_UPDTABLE)
+		printk(" UPDTABLE");
+	if(p->mosix.dupdates & DFSA_UPDCDIR)
+		printk(" UPDCDIR");
+	if(p->mosix.dupdates & DFSA_UPDCDIR)
+		printk(" UPDCDIR");
+	if(p->mosix.dupdates & DFSA_UPDCLOSE)
+		printk(" UPDCLOSE");
+	if(p->mosix.dupdates & DFSA_UPDMODS)
+		printk(" UPDMODS");
+	if(p->mosix.dupdates & DFSA_UPDUSED)
+		printk(" UPDUSED");
+	printk("\n");
+	printset("Files to close", files->maxclosed, files->closed);
+	printset("Files to modify", files->maxmod, files->modified);
+	if(p->mosix.ttab)
+		printk("DFSA table at 0x%x of size %d\n",
+			(int)p->mosix.ttab, p->mosix.ttab->len);
+	else
+		printk("No DFSA table.\n");
+	printset("Open files", p->files->max_fdset, p->files->open_fds);
+	if(p == current)
+	{
+		printk("DFSA files:\n");
+		for(i = 0 ; i < files->max_fds ; i++)
+		if((fs = can_dfsa_file(i)))
+		{
+			printk("%d: #%d/%d\n", i, fs,
+				(int)files->fd[i]->f_dentry->d_inode->i_ino);
+		}
+	}
+	else
+	{
+		printk("file/count/dfsano/ino:");
+		for(i = 0 ; i < files->max_fds ; i++)
+		if((f = files->fd[i]))
+		{
+			printk(" %d:%d/#%d/%d", i, file_count(f),
+				f->f_vfsmnt->mnt_dfsano ? : -9,
+				(int)f->f_dentry->d_inode->i_ino);
+		}
+		printk("\n");
+	}
+}
+
+#endif /* CONFIG_MOSIX_DFSA */
